Description

I'm not sure whether this is was introduced with #36913, but the POST/PUT arguments are currently not merged with the arguments
set from the router but instead Router::route() overrides arguments with the same name.

Related issues:
related to TYPO3.Flow - Bug # 36913: HTTP PUT data not regonized as arguments Resolved 2012-05-07

Associated revisions
Revision 170733fb - 2012-05-30 14:45 - Bastian Waidelich

[BUGFIX] Router overrides request arguments

With the reworked Request stack, the router kicks in after
the action request have been built, overriding all arguments
the respective route specifies.

This works for the most cases, but leads to issues when you
try to specify part of a complex target argument via the route
and part via request.

For example if you update a domain model via request body but
specify the model itself through the URI like
http://domain/products/product-1 - now the Identity-RoutePart
detects "product-1" and turns it into the corresponding
__identity-array but then the Router kicks in and overrides
the "product" argument completely resulting in a new object
to be created by the property mapper.

This change adjusts the Router to recursively merge arguments
with the route values instead, with precedence to the route
values.

Change-Id: I22edc9e871b8b6e5baa731fe30e944f3e5575d05
Fixes: #37445
Releases: 1.1, 1.2

Revision 4ffcef32 - 2012-05-30 15:01 - Bastian Waidelich

[BUGFIX] Router overrides request arguments

2015-08-03 1/3

http://domain/products/product-1


With the reworked Request stack, the router kicks in after
the action request have been built, overriding all arguments
the respective route specifies.

This works for the most cases, but leads to issues when you
try to specify part of a complex target argument via the route
and part via request.

For example if you update a domain model via request body but
specify the model itself through the URI like
http://domain/products/product-1 - now the Identity-RoutePart
detects "product-1" and turns it into the corresponding
__identity-array but then the Router kicks in and overrides
the "product" argument completely resulting in a new object
to be created by the property mapper.

This change adjusts the Router to recursively merge arguments
with the route values instead, with precedence to the route
values.

Change-Id: I22edc9e871b8b6e5baa731fe30e944f3e5575d05
Fixes: #37445
Releases: 1.1, 1.2

History
#1 - 2012-05-24 10:27 - Bastian Waidelich
- Category changed from MVC to MVC - Routing
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

#2 - 2012-05-25 09:40 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 RC1

#3 - 2012-05-30 14:40 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11732

#4 - 2012-05-30 14:41 - Bastian Waidelich
- Target version changed from 1.1 RC1 to 1.1 beta 2

#5 - 2012-05-30 14:47 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11732

#6 - 2012-05-30 15:01 - Gerrit Code Review
Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/11735

#7 - 2012-05-30 15:38 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4ffcef32bca0ee9d05c743126ce9c4fd0904d726.
